const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const item_categories = sequelize.define(
    'item_categories',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

category_name: {
        type: DataTypes.TEXT,
      
      

      },

category_code: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  item_categories.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.item_categories.hasMany(db.items, {
      as: 'items_category',
      foreignKey: {
          name: 'categoryId',
      },
      constraints: false,
    });





























//end loop






    db.item_categories.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.item_categories.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return item_categories;
};


